<?php
/*---------------------------------------------------------------*/
/*
    Titre : Compter le nombre de mots ayant un certain caractère                                                         
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=581
    Auteur           : mercier133                                                                                         
    Date dition     : 27 Mars 2010                                                                                       
    Date mise  jour : 11 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    - modification de la description                                                                                      
*/
/*---------------------------------------------------------------*/ 

    /*
     * @Entrée : $string un string et $c un caractère
     * @Sortie : (int) nombre de mot dans $string contenant la caractère $c
     */
    function countWordsWithChar($string,$c){
      $mots = preg_split("/[\s,;\.!\?:]+/", $string);
      $count = 0;
      foreach($mots as $mot){
        if(preg_match("/$c/",$mot)){
          $count++;
        }
      }
      return $count;
    }

    /*
     * @Entrée : $string un string et $c un caractère
     * @Sortie : (int) nombre de mot dans $string contenant la caractère $c 
     * qu'il soit majuscule ou minuscule (insensible à la case)
     */
    function countWordsWithCharCaseInsensitive($string,$c){
      $mots = preg_split("/[\s,;\.!\?:]+/", $string);
      $count = 0;
      foreach($mots as $mot){
        if(preg_match("/$c/i",$mot,$result)){
          $count++;
        }
      }
      return $count;
    }
?>